<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
<meta name="generator" content="pdoc 0.7.1" />
<title>models.layers.layers API documentation</title>
<meta name="description" content="" />
<link href='https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.0/normalize.min.css' rel='stylesheet'>
<link href='https://cdnjs.cloudflare.com/ajax/libs/10up-sanitize.css/8.0.0/sanitize.min.css' rel='stylesheet'>
<link href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" rel="stylesheet">
<style>.flex{display:flex !important}body{line-height:1.5em}#content{padding:20px}#sidebar{padding:30px;overflow:hidden}.http-server-breadcrumbs{font-size:130%;margin:0 0 15px 0}#footer{font-size:.75em;padding:5px 30px;border-top:1px solid #ddd;text-align:right}#footer p{margin:0 0 0 1em;display:inline-block}#footer p:last-child{margin-right:30px}h1,h2,h3,h4,h5{font-weight:300}h1{font-size:2.5em;line-height:1.1em}h2{font-size:1.75em;margin:1em 0 .50em 0}h3{font-size:1.4em;margin:25px 0 10px 0}h4{margin:0;font-size:105%}a{color:#058;text-decoration:none;transition:color .3s ease-in-out}a:hover{color:#e82}.title code{font-weight:bold}h2[id^="header-"]{margin-top:2em}.ident{color:#900}pre code{background:#f8f8f8;font-size:.8em;line-height:1.4em}code{background:#f2f2f1;padding:1px 4px;overflow-wrap:break-word}h1 code{background:transparent}pre{background:#f8f8f8;border:0;border-top:1px solid #ccc;border-bottom:1px solid #ccc;margin:1em 0;padding:1ex}#http-server-module-list{display:flex;flex-flow:column}#http-server-module-list div{display:flex}#http-server-module-list dt{min-width:10%}#http-server-module-list p{margin-top:0}.toc ul,#index{list-style-type:none;margin:0;padding:0}#index code{background:transparent}#index h3{border-bottom:1px solid #ddd}#index ul{padding:0}#index h4{font-weight:bold}#index h4 + ul{margin-bottom:.6em}@media (min-width:200ex){#index .two-column{column-count:2}}@media (min-width:300ex){#index .two-column{column-count:3}}dl{margin-bottom:2em}dl dl:last-child{margin-bottom:4em}dd{margin:0 0 1em 3em}#header-classes + dl > dd{margin-bottom:3em}dd dd{margin-left:2em}dd p{margin:10px 0}.name{background:#eee;font-weight:bold;font-size:.85em;padding:5px 10px;display:inline-block;min-width:40%}.name:hover{background:#e0e0e0}.name > span:first-child{white-space:nowrap}.name.class > span:nth-child(2){margin-left:.4em}.inherited{color:#999;border-left:5px solid #eee;padding-left:1em}.inheritance em{font-style:normal;font-weight:bold}.desc h2{font-weight:400;font-size:1.25em}.desc h3{font-size:1em}.desc dt code{background:inherit}.source summary,.git-link-div{color:#666;text-align:right;font-weight:400;font-size:.8em;text-transform:uppercase}.source summary > *{white-space:nowrap;cursor:pointer}.git-link{color:inherit;margin-left:1em}.source pre{max-height:500px;overflow:auto;margin:0}.source pre code{font-size:12px;overflow:visible}.hlist{list-style:none}.hlist li{display:inline}.hlist li:after{content:',\2002'}.hlist li:last-child:after{content:none}.hlist .hlist{display:inline;padding-left:1em}img{max-width:100%}.admonition{padding:.1em .5em;margin-bottom:1em}.admonition-title{font-weight:bold}.admonition.note,.admonition.info,.admonition.important{background:#aef}.admonition.todo,.admonition.versionadded,.admonition.tip,.admonition.hint{background:#dfd}.admonition.warning,.admonition.versionchanged,.admonition.deprecated{background:#fd4}.admonition.error,.admonition.danger,.admonition.caution{background:lightpink}</style>
<style media="screen and (min-width: 700px)">@media screen and (min-width:700px){#sidebar{width:30%}#content{width:70%;max-width:100ch;padding:3em 4em;border-left:1px solid #ddd}pre code{font-size:1em}.item .name{font-size:1em}main{display:flex;flex-direction:row-reverse;justify-content:flex-end}.toc ul ul,#index ul{padding-left:1.5em}.toc > ul > li{margin-top:.5em}}</style>
<style media="print">@media print{#sidebar h1{page-break-before:always}.source{display:none}}@media print{*{background:transparent !important;color:#000 !important;box-shadow:none !important;text-shadow:none !important}a[href]:after{content:" (" attr(href) ")";font-size:90%}a[href][title]:after{content:none}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}pre,blockquote{border:1px solid #999;page-break-inside:avoid}thead{display:table-header-group}tr,img{page-break-inside:avoid}img{max-width:100% !important}@page{margin:0.5cm}p,h2,h3{orphans:3;widows:3}h1,h2,h3,h4,h5,h6{page-break-after:avoid}}</style>
</head>
<body>
<main>
<article id="content">
<header>
<h1 class="title">Module <code>models.layers.layers</code></h1>
</header>
<section id="section-intro">
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">import math

import keras
from keras.models import Model, load_model
from keras.layers import Input, BatchNormalization, Activation
from keras.layers.core import Lambda, Dropout
from keras.layers.convolutional import Conv2D, Conv2DTranspose, UpSampling2D
from keras.layers.convolutional_recurrent import ConvLSTM2D
from keras.layers.pooling import MaxPooling2D
from keras.layers.merge import Concatenate, Add
from keras import regularizers
from keras import backend as K

import tensorflow as tf

def activation_function(inputs, acti):
    if isinstance(acti, str):
        return Activation(acti)(inputs)
    else:
        return acti(inputs)

def regularizer_function(weight_regularizer):
    if weight_regularizer == 0 or weight_regularizer == None:
        return None
    else:
        return regularizers.l2(weight_regularizer)
    
def bn_relu_conv2d(inputs, filters, filter_size, 
                    strides = 1, acti = None, padding = None, 
                    kernel_initializer = None, weight_regularizer = None, name = &#34;&#34;):
    output = BatchNormalization()(inputs)
    output = activation_function(output, acti)
    output = Conv2D(filters, (filter_size, filter_size), padding=padding, strides = strides,
                    kernel_initializer=kernel_initializer, 
                    kernel_regularizer=regularizer_function(weight_regularizer))(output)
            
    return output

def bn_relu_conv2dtranspose(inputs, filters, filter_size, 
                            strides = 2, acti = None, padding = None, 
                            kernel_initializer = None, weight_regularizer = None, name = &#34;&#34;):
    output = BatchNormalization()(inputs)
    output = activation_function(output, acti)
    output = Conv2DTranspose(filters, (2, 2), strides=strides, padding=padding, 
                             kernel_initializer=kernel_initializer, 
                             kernel_regularizer=regularizer_function(weight_regularizer))(output)
    return output

def normalize_input(inputs, scale_input = False, mean_std_normalization = False, mean = None, std = None):
    if mean_std_normalization is True:
        print(&#34;Using normalization&#34;)
        return Lambda(lambda x: (x - mean)/std)(inputs)
    elif scale_input is True:
        print(&#34;Not using normalization&#34;)
        return Lambda(lambda x: x / 255)(inputs)
    else:
        return inputs
            
    </code></pre>
</details>
</section>
<section>
</section>
<section>
</section>
<section>
<h2 class="section-title" id="header-functions">Functions</h2>
<dl>
<dt id="models.layers.layers.activation_function"><code class="name flex">
<span>def <span class="ident">activation_function</span></span>(<span>inputs, acti)</span>
</code></dt>
<dd>
<section class="desc"></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def activation_function(inputs, acti):
    if isinstance(acti, str):
        return Activation(acti)(inputs)
    else:
        return acti(inputs)</code></pre>
</details>
</dd>
<dt id="models.layers.layers.bn_relu_conv2d"><code class="name flex">
<span>def <span class="ident">bn_relu_conv2d</span></span>(<span>inputs, filters, filter_size, strides=1, acti=None, padding=None, kernel_initializer=None, weight_regularizer=None, name='')</span>
</code></dt>
<dd>
<section class="desc"></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def bn_relu_conv2d(inputs, filters, filter_size, 
                    strides = 1, acti = None, padding = None, 
                    kernel_initializer = None, weight_regularizer = None, name = &#34;&#34;):
    output = BatchNormalization()(inputs)
    output = activation_function(output, acti)
    output = Conv2D(filters, (filter_size, filter_size), padding=padding, strides = strides,
                    kernel_initializer=kernel_initializer, 
                    kernel_regularizer=regularizer_function(weight_regularizer))(output)
            
    return output</code></pre>
</details>
</dd>
<dt id="models.layers.layers.bn_relu_conv2dtranspose"><code class="name flex">
<span>def <span class="ident">bn_relu_conv2dtranspose</span></span>(<span>inputs, filters, filter_size, strides=2, acti=None, padding=None, kernel_initializer=None, weight_regularizer=None, name='')</span>
</code></dt>
<dd>
<section class="desc"></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def bn_relu_conv2dtranspose(inputs, filters, filter_size, 
                            strides = 2, acti = None, padding = None, 
                            kernel_initializer = None, weight_regularizer = None, name = &#34;&#34;):
    output = BatchNormalization()(inputs)
    output = activation_function(output, acti)
    output = Conv2DTranspose(filters, (2, 2), strides=strides, padding=padding, 
                             kernel_initializer=kernel_initializer, 
                             kernel_regularizer=regularizer_function(weight_regularizer))(output)
    return output</code></pre>
</details>
</dd>
<dt id="models.layers.layers.normalize_input"><code class="name flex">
<span>def <span class="ident">normalize_input</span></span>(<span>inputs, scale_input=False, mean_std_normalization=False, mean=None, std=None)</span>
</code></dt>
<dd>
<section class="desc"></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def normalize_input(inputs, scale_input = False, mean_std_normalization = False, mean = None, std = None):
    if mean_std_normalization is True:
        print(&#34;Using normalization&#34;)
        return Lambda(lambda x: (x - mean)/std)(inputs)
    elif scale_input is True:
        print(&#34;Not using normalization&#34;)
        return Lambda(lambda x: x / 255)(inputs)
    else:
        return inputs</code></pre>
</details>
</dd>
<dt id="models.layers.layers.regularizer_function"><code class="name flex">
<span>def <span class="ident">regularizer_function</span></span>(<span>weight_regularizer)</span>
</code></dt>
<dd>
<section class="desc"></section>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def regularizer_function(weight_regularizer):
    if weight_regularizer == 0 or weight_regularizer == None:
        return None
    else:
        return regularizers.l2(weight_regularizer)</code></pre>
</details>
</dd>
</dl>
</section>
<section>
</section>
</article>
<nav id="sidebar">
<h1>Index</h1>
<div class="toc">
<ul></ul>
</div>
<ul id="index">
<li><h3>Super-module</h3>
<ul>
<li><code><a title="models.layers" href="index.html">models.layers</a></code></li>
</ul>
</li>
<li><h3><a href="#header-functions">Functions</a></h3>
<ul class="">
<li><code><a title="models.layers.layers.activation_function" href="#models.layers.layers.activation_function">activation_function</a></code></li>
<li><code><a title="models.layers.layers.bn_relu_conv2d" href="#models.layers.layers.bn_relu_conv2d">bn_relu_conv2d</a></code></li>
<li><code><a title="models.layers.layers.bn_relu_conv2dtranspose" href="#models.layers.layers.bn_relu_conv2dtranspose">bn_relu_conv2dtranspose</a></code></li>
<li><code><a title="models.layers.layers.normalize_input" href="#models.layers.layers.normalize_input">normalize_input</a></code></li>
<li><code><a title="models.layers.layers.regularizer_function" href="#models.layers.layers.regularizer_function">regularizer_function</a></code></li>
</ul>
</li>
</ul>
</nav>
</main>
<footer id="footer">
<p>Generated by <a href="https://pdoc3.github.io/pdoc"><cite>pdoc</cite> 0.7.1</a>.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad()</script>
</body>
</html>